#include <cstdio>
#include <cmath>
#include "Neuron.h"

using namespace std;

int
main(void)
{
  NeuralNet net(3, 3, 100, 1);

  double DataIn[10][3] = 
  {
    { 1.0, 2.0, 3.0 },
    { 1.0, 1.0, 1.0 },
    { 3.0, 2.0, 3.0 },
    { 4.0, 3.0, 2.0 },
    { 1.0, 7.0, 5.0 },
    { 10.0, -2.0, 3.0 },
    { 9.0, 2.0, 7.0 },
    { 1.0, 5.0, 3.0 },
    { 5.0, 2.0, 3.0 },
    { 8.0, 1.0, 3.0 }
  };
  double DataOut[1];
  double DataCorrect [10] = 
  { 3.0, 1.5, 4.0, 4.5, 6.5, 5.5, 9.0, 4.5, 5.0, 6.0 };
  int i, j;

  for(j = 0; j < 10; j++)
  {
    double MaxErrorPercent = 0.0;

    printf("Phase %i\n", j);
    for(i = 0; i < 10; i++)
    {
//    net.Dump();
    net.Go(DataIn[i], DataOut);
    printf("Correct: %.3f -> Out: %.3f\n", DataCorrect[i], DataOut[0]);
//    net.Dump();
    if(DataOut[0] != DataCorrect[i])
    {
      double Error = fabs(DataCorrect[i] - DataOut[0]) / DataCorrect[i];
      net.ErrorCorrection(0.0001, &DataCorrect[i]);
      if(Error > MaxErrorPercent)
        MaxErrorPercent = Error;

    }
//    net.Dump();
    }
    printf("Phase %i max error: %.3f%%\n", j, MaxErrorPercent);
    if(MaxErrorPercent < 0.0001)
      break;
  }

  double LastTestData[3] = { 100.0, 200.0, 300.0 };
  net.Go(LastTestData, DataCorrect);
  printf("Last test (should be 300.000): %.3f", DataCorrect[0]);

  return 0;
}

